// WARNING: DO NOT EDIT THIS FILE. THIS FILE IS MANAGED BY SPRING ROO.
// You may push code into the target .java compilation unit if you wish to edit any member(s).

package org.neo4j.app.trivialt.web;

import java.io.UnsupportedEncodingException;
import java.lang.Integer;
import java.lang.Long;
import java.lang.String;
import java.util.Collection;
import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;
import org.neo4j.app.trivialt.model.Card;
import org.neo4j.app.trivialt.model.Deck;
import org.neo4j.app.trivialt.model.Proposal;
import org.neo4j.app.trivialt.model.Round;
import org.springframework.ui.Model;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.util.UriUtils;
import org.springframework.web.util.WebUtils;

privileged aspect CardController_Roo_Controller {
    
    @RequestMapping(method = RequestMethod.POST)
    public String CardController.create(@Valid Card card, BindingResult bindingResult, Model uiModel, HttpServletRequest httpServletRequest) {
        if (bindingResult.hasErrors()) {
            uiModel.addAttribute("card", card);
            return "api/cards/create";
        }
        uiModel.asMap().clear();
        card.save();
        return "redirect:/api/cards/" + encodeUrlPathSegment(card.getId().toString(), httpServletRequest);
    }
    
    @RequestMapping(params = "form", method = RequestMethod.GET)
    public String CardController.createForm(Model uiModel) {
        uiModel.addAttribute("card", new Card());
        return "api/cards/create";
    }
    
    @RequestMapping(value = "/{id}", method = RequestMethod.GET)
    public String CardController.show(@PathVariable("id") Long id, Model uiModel) {
        uiModel.addAttribute("card", Card.findCard(id));
        uiModel.addAttribute("itemId", id);
        return "api/cards/show";
    }
    
    @RequestMapping(method = RequestMethod.GET)
    public String CardController.list(@RequestParam(value = "page", required = false) Integer page, @RequestParam(value = "size", required = false) Integer size, Model uiModel) {
        if (page != null || size != null) {
            int sizeNo = size == null ? 10 : size.intValue();
            uiModel.addAttribute("cards", Card.findPaged(page == null ? 0 : (page.intValue() - 1) * sizeNo, sizeNo));
            float nrOfPages = (float) Card.count() / sizeNo;
            uiModel.addAttribute("maxPages", (int) ((nrOfPages > (int) nrOfPages || nrOfPages == 0.0) ? nrOfPages + 1 : nrOfPages));
        } else {
            uiModel.addAttribute("cards", Card.findAll());
        }
        return "api/cards/list";
    }
    
    @RequestMapping(value = "/{id}", params = "form", method = RequestMethod.GET)
    public String CardController.updateForm(@PathVariable("id") Long id, Model uiModel) {
        uiModel.addAttribute("card", Card.findCard(id));
        return "api/cards/update";
    }
    
    @RequestMapping(value = "/{id}", method = RequestMethod.DELETE)
    public String CardController.delete(@PathVariable("id") Long id, @RequestParam(value = "page", required = false) Integer page, @RequestParam(value = "size", required = false) Integer size, Model uiModel) {
        Card.findCard(id).delete();
        uiModel.asMap().clear();
        uiModel.addAttribute("page", (page == null) ? "1" : page.toString());
        uiModel.addAttribute("size", (size == null) ? "10" : size.toString());
        return "redirect:/api/cards";
    }
    
    @ModelAttribute("cards")
    public Collection<Card> CardController.populateCards() {
        return Card.findAll();
    }
    
    @ModelAttribute("decks")
    public Collection<Deck> CardController.populateDecks() {
        return Deck.findAll();
    }
    
    @ModelAttribute("proposals")
    public Collection<Proposal> CardController.populateProposals() {
        return Proposal.findAll();
    }
    
    @ModelAttribute("rounds")
    public Collection<Round> CardController.populateRounds() {
        return Round.findAll();
    }
    
    String CardController.encodeUrlPathSegment(String pathSegment, HttpServletRequest httpServletRequest) {
        String enc = httpServletRequest.getCharacterEncoding();
        if (enc == null) {
            enc = WebUtils.DEFAULT_CHARACTER_ENCODING;
        }
        try {
            pathSegment = UriUtils.encodePathSegment(pathSegment, enc);
        }
        catch (UnsupportedEncodingException uee) {}
        return pathSegment;
    }
    
}
