// WARNING: DO NOT EDIT THIS FILE. THIS FILE IS MANAGED BY SPRING ROO.
// You may push code into the target .java compilation unit if you wish to edit any member(s).

package org.neo4j.app.trivialt.web;

import java.io.UnsupportedEncodingException;
import java.lang.Integer;
import java.lang.Long;
import java.lang.String;
import java.util.Collection;
import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;
import org.neo4j.app.trivialt.model.Card;
import org.neo4j.app.trivialt.model.Deck;
import org.neo4j.app.trivialt.model.Match;
import org.neo4j.app.trivialt.model.Team;
import org.springframework.ui.Model;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.util.UriUtils;
import org.springframework.web.util.WebUtils;

privileged aspect DeckController_Roo_Controller {
    
    @RequestMapping(method = RequestMethod.POST)
    public String DeckController.create(@Valid Deck deck, BindingResult bindingResult, Model uiModel, HttpServletRequest httpServletRequest) {
        if (bindingResult.hasErrors()) {
            uiModel.addAttribute("deck", deck);
            return "api/decks/create";
        }
        uiModel.asMap().clear();
        deck.save();
        return "redirect:/api/decks/" + encodeUrlPathSegment(deck.getId().toString(), httpServletRequest);
    }
    
    @RequestMapping(params = "form", method = RequestMethod.GET)
    public String DeckController.createForm(Model uiModel) {
        uiModel.addAttribute("deck", new Deck());
        return "api/decks/create";
    }
    
    @RequestMapping(value = "/{id}", method = RequestMethod.GET)
    public String DeckController.show(@PathVariable("id") Long id, Model uiModel) {
        uiModel.addAttribute("deck", Deck.findDeck(id));
        uiModel.addAttribute("itemId", id);
        return "api/decks/show";
    }
    
    @RequestMapping(method = RequestMethod.GET)
    public String DeckController.list(@RequestParam(value = "page", required = false) Integer page, @RequestParam(value = "size", required = false) Integer size, Model uiModel) {
        if (page != null || size != null) {
            int sizeNo = size == null ? 10 : size.intValue();
            uiModel.addAttribute("decks", Deck.findPaged(page == null ? 0 : (page.intValue() - 1) * sizeNo, sizeNo));
            float nrOfPages = (float) Deck.count() / sizeNo;
            uiModel.addAttribute("maxPages", (int) ((nrOfPages > (int) nrOfPages || nrOfPages == 0.0) ? nrOfPages + 1 : nrOfPages));
        } else {
            uiModel.addAttribute("decks", Deck.findAll());
        }
        return "api/decks/list";
    }
    
    @RequestMapping(value = "/{id}", params = "form", method = RequestMethod.GET)
    public String DeckController.updateForm(@PathVariable("id") Long id, Model uiModel) {
        uiModel.addAttribute("deck", Deck.findDeck(id));
        return "api/decks/update";
    }
    
    @RequestMapping(value = "/{id}", method = RequestMethod.DELETE)
    public String DeckController.delete(@PathVariable("id") Long id, @RequestParam(value = "page", required = false) Integer page, @RequestParam(value = "size", required = false) Integer size, Model uiModel) {
        Deck.findDeck(id).delete();
        uiModel.asMap().clear();
        uiModel.addAttribute("page", (page == null) ? "1" : page.toString());
        uiModel.addAttribute("size", (size == null) ? "10" : size.toString());
        return "redirect:/api/decks";
    }
    
    @ModelAttribute("cards")
    public Collection<Card> DeckController.populateCards() {
        return Card.findAll();
    }
    
    @ModelAttribute("decks")
    public Collection<Deck> DeckController.populateDecks() {
        return Deck.findAll();
    }
    
    @ModelAttribute("matches")
    public Collection<Match> DeckController.populateMatches() {
        return Match.findAll();
    }
    
    @ModelAttribute("teams")
    public Collection<Team> DeckController.populateTeams() {
        return Team.findAll();
    }
    
    String DeckController.encodeUrlPathSegment(String pathSegment, HttpServletRequest httpServletRequest) {
        String enc = httpServletRequest.getCharacterEncoding();
        if (enc == null) {
            enc = WebUtils.DEFAULT_CHARACTER_ENCODING;
        }
        try {
            pathSegment = UriUtils.encodePathSegment(pathSegment, enc);
        }
        catch (UnsupportedEncodingException uee) {}
        return pathSegment;
    }
    
}
